SELECT categname, subcategname, sumamounts, (case when totmo = cast(totmo as integer) then cast(totmo as integer) else 1 + cast(totmo as integer) end) as totalmonths, sumamounts/(case when totmo = cast(totmo as integer) then cast(totmo as integer) else 1 + cast(totmo as integer) end) as average
FROM	[SUBCATEGORY_V1] stab,
		[CATEGORY_V1] ctab,
		(SELECT cid, sid, sum(amnt) as sumamounts
		FROM (
			SELECT CATEGID cid, SUBCATEGID sid, TRANSAMOUNT amnt
			FROM [CHECKINGACCOUNT_V1]
			where transcode = 'Withdrawal'
			and payeeid <> 15
			and categid <> -1
			union all
			SELECT b.CATEGID, b.SUBCATEGID, b.SPLITTRANSAMOUNT
			FROM [CHECKINGACCOUNT_V1] a, [SPLITTRANSACTIONS_V1] b
			where a.transcode = 'Withdrawal'
			and a.payeeid <> 15
			and a.categid = -1
			and a.transid = b.transid
		)
		group by cid, sid
	) totalentries,
	(SELECT (julianday(max(MAXDATE))-julianday(min(MINDATE))) / 30 as totmo
	FROM (
		SELECT min(TRANSDATE) as MINDATE, max(transdate) as MAXDATE
		FROM [CHECKINGACCOUNT_V1]
		where transcode = 'Withdrawal'
		and payeeid <> 15
		and categid <> -1
		union all
		SELECT min(TRANSDATE) as MINDATE, max(transdate) as MAXDATE
		FROM [CHECKINGACCOUNT_V1] a, [SPLITTRANSACTIONS_V1] b
		where a.transcode = 'Withdrawal'
		and a.payeeid <> 15
		and a.categid = -1
		and a.transid = b.transid
		)
	)
where stab.subcategid = totalentries.sid
and ctab.categid = totalentries.cid
group by categname, subcategname
;